<?php
  /**
   * Single User Blog Profile
   * All the functionality of a single-user blog platform such as the 'w' word, but utilising the power of Drupal.
   * author: George2
   * Overseen by Add1sun

   * ?what about namespaces - should profiles adhere to them?

   * TO DO:
	 * why isn't the first task submit form being caught?
   * for themeing can we have a different colourable theme?
	 * maybe a little module to allow the user to change the header image - is that in johnalbin's theme api?
   * post date and author info to be hidden?
   * views to be set up, using the default frontpage view, maybe ask user upon setup what blocks they want and where?
   * the user could technically screw things up by disabling clean urls on the page, so if it's enabled, can it be hidden on the install profile form?
	* should cron be run for the user for the first time - maybe explain how to set up cron for the user? 
	* i really don't want to use the taxonomy_term view because: it doesn't display the description of the category, and it's not easy to change results per page - though i'll prolly end up using it
	* set up content types with comments, flat list expanded or threaded expanded - to ask during installation, subject field to be disabled - to ask, put comment submission form below comments, preview comment optional or required?
	* allow anonymous comment posting, and set permissions as necessary
	* rewrite sample content 
	* admin menu to make life easier for newbies
	* clear feedback messages during installation?
	
	// tasks
   * the setting up of pathauto during installation with some radio options for user to choose, blog path format - like: 2008/10/05/my-blog-title, or tag1/tag2/my-blog-title etc for blog posts
	* user pictures, and whether inside comments - ask user if they want this and enable as such, and to upload an avatar during installation?
	* set what the front page is - either blog or some other page
	* allow user to change colour of theme - yay!
	* create sample content?

	* currently the block title from the archive view block is missing, but not the recent comments view block - i'm 90% sure this is a views issue, and alerted merlin. i feel putting a title in here manually is not solving the problem.
	
	* as a complete aside, it'd be REALLY nifty if thumbs/icons could be placed next to the radio options where you choose the profile.
	* to link block config to view block config would also be handy for newbies
  */
  
  /** 
  * Return basic description
  * @return
  *  Array of keys 'name', and 'description'
  */
  function single_user_blog_profile_details(){
    return array(
      'name' => 'Single User Blog',
      'description' => 'Install Drupal as a blogging platform.',
    );
  }
  
  /**
  * Define what modules we need
  * @return
  *  array of modules to be required and activated
  */
  function single_user_blog_profile_modules(){
    return array(
      // enable some basic core modules
			'help', 'taxonomy', 'path', 'search', 'comment', 'contact', 'color', 'menu',
      // 'dblog', 'aggregator', 'ping', 'poll', // to ask if these are needed during install - is that possible?
			
      // for views functionality
      'views', 'views_ui', // technically ui doesn't need to be enabled, but until simlpe_views is used... ?
      
      // path related
      'pathauto', 'token',
      
      // captcha for now
      //'captcha', 
      // captcha pack would be nice to be able to require, but it's a collection of modules, and not one, 
      
      // comment control
      // like 'flag this' as abusive or inappropriate etc
      
      // rte
      // not yet :) - i'm liking htmlbox though atm
      
      // cck ?
      // would be nice to allow adding custom fields - not really needed though
      
      // allow users to schedule blog posts at a later date
			//'scheduler',
      
      // image handling
      // go imce! / imagefied / image / secret thing i'm working on
			
			// i think this is worth it!
			'admin_menu', 

			// during dev, this is to help me
			//'devel', 'devel_generate',
    );
  }
  
  /**
  * Additional installation tasks
  */
  function single_user_blog_profile_task_list(){
		return array (
			'userpicture_setup' => 'Avatars',
			'pathauto_setup' => 'Paths',
			'colour_setup' => 'Colours',
			'frontpage_setup' => 'Front Page',
			'createsamplecontent' => 'Sample Content',
		);
  }
  
  /**
  * final installation tasks
  * set up views, define content type, enable basic captcha?
  */
  function single_user_blog_profile_tasks(&$task, $url){
		// first run of this function
    if ($task == 'profile'){
			/**
			* set up content types - shamelessly copied and changed from the default.profile
			*/
			$types = array(
				array(
					'type' => 'page',
					'name' => st('Page'),
					'module' => 'node',
					'description' => st("A <em>page</em> are static pages that don't change. An example would be an about page. Comments are disabled by default."),
					'custom' => TRUE,
					'modified' => TRUE,
					'locked' => FALSE,
					'help' => '',
					'min_word_count' => '',
				),
				array(
					'type' => 'blog_entry',
					'name' => st('Blog Entry'),
					'module' => 'node',
					'description' => st("A <em>Blog Entry</em> is where you write your blog entries. Blog entries are feautred on the site'\s home page, and allows users to post comments."),
					'custom' => TRUE,
					'modified' => TRUE,
					'locked' => FALSE,
					'help' => '',
					'min_word_count' => '',
				),
			);
			foreach ($types as $type) {
				$type = (object) _node_type_set_defaults($type);
				node_type_save($type);
			}

			// Default page to not be promoted and have comments disabled for pages.
			variable_set('node_options_page', array('status'));
			variable_set('comment_page', COMMENT_NODE_DISABLED);
			
			// do i have to set up promote, status for blog_entry?
			

			// Don't display date and author information for page nodes and blog entries by default.
			$theme_settings = variable_get('theme_settings', array());
			$theme_settings['toggle_node_info_page'] = FALSE;
			variable_set('theme_settings', $theme_settings);

			// Update the menu router information - is this necessary?
			menu_rebuild();
			
			/** 
			* taxonomy
			*/
			// create taxonomy tags vocabulary
			$vocab = array(
				'name' => st('Blog tags'),
				'description' => st('What keywords best describe this post.'),
				'help' => st('You can enter as many tags as you think are appropriate.'),
				'hierarchy' => FALSE,
				'relations' => FALSE,
				'tags' => TRUE,
				'multiple' => TRUE,
				'required' => TRUE, // debatable
			);
			taxonomy_save_vocabulary($vocab);
			
			// TODO:	need to set this vocab up to be used on blog_entry

			/**
			* views
			*/
			// enable archive and recent comments views - the default views var should initially be non-existant, but let's try and get it just in case a module does something funky
			$views_default = variable_get('views_default', array());
			$views_default['archive'] = FALSE;
			$views_default['comments_recent'] = FALSE;
			variable_set('views_defaults', $views_default);	// this isn't exposing the blocks?

			// these two lines ripped from views/admin.inc  -function views_ui_enable_page
			views_invalidate_cache();
			menu_rebuild();				
			
			// set up custom views
			_single_user_blog_setup_views();

			/** 
			* blocks
			*/
			// painfully found out we need to manually initiate block creation for modules - should that be right?
			global $theme, $theme_key;
			$theme = 'garland';
			$theme_key = $theme;	// these two need to be hardcoded - fugly i know :/
			_block_rehash();	// manulally create blocks for all modules - fugly :/
			
			// show latest comments block in right hand side of garland - is this ok to assume? - maybe get list of enabled themes so other themes can be activated?
			$form_state = array(
				'values' => array(
					array(
						'delta' => 'comments_recent-block',
						'status' => TRUE,
						'region' => 'right',
						'weight' => 0,
						'throttle' => 0,
						'theme' => 'garland',
						'module' => 'views',
					),
					array(
						'delta' => 'archive-block',
						'status' => TRUE,
						'region' => 'right',
						'weight' => 1,
						'throttle' => 0,
						'theme' => 'garland',
						'module' => 'views',
					),
				),
			);
			// include block admin, and call block display_form_submit
			module_load_include('admin.inc', 'block', 'block');
			block_admin_display_form_submit(array(), &$form_state);
			
			/**
				block all public signups
			*/
			variable_set('user_register', 0);
			
			/**
				enable normal page cache, page compression, javascript & css aggregation and block cache
			*/
			variable_set('cache', CACHE_NORMAL);
			variable_set('page_compression', TRUE);
			variable_set('block_cache', TRUE);
			variable_set('preprocess_js', TRUE);
			variable_set('preprocess_css', TRUE);
			
			// onto the next step we go
			$task = 'pathauto_setup';
			return drupal_get_form('pathauto_setup_form', $url);
		}

		if ($task == 'pathauto_setup'){
			// check that form is processed otherwise show?
			$form = drupal_get_form('pathauto_setup_form', $url);

			// has form been processed
			if (variable_get('pathauto_setup', FALSE)){
				variable_del('pathauto_setup');

				$task = 'userpicture_setup';			
				drupal_set_title(st('Avatars'));
				$output = '<p>' . st('Do you want an avatar or picture to represent yourself? It can be shown on posts and comments you make.') . '</p>';
				$output .= l('continue',  $url);
				return $output;
			}
			// nope
			else{
				return drupal_get_form('pathauto_setup_form', $url);
			}
		}

		// allow user to upload their own default avatar - is the admin user created at this point?
		if ($task == 'userpicture_setup'){
//				die (var_dump(get_defined_vars()));
			$task = 'frontpage_setup';	
			drupal_set_title(st('Frontpage Setup'));
			$output = '<p>' . st('Customise your front page...') . '</p>';
			$output .= l('continue',  $url);
			return $output;
		}

		if ($task == 'frontpage_setup'){
			$task = 'colour_setup';	
			drupal_set_title(st('Colours'));
			$output = '<p>' . st('Customise colours.') . '</p>';
			$output .= l('continue',  $url);
			return $output;
		}

		if ($task == 'colour_setup'){
			$task = 'createsamplecontent';	
			drupal_set_title(st('Sample Content'));
			$output = '<p>' . st('Create sample content?') . '</p>';
			$output .= l('continue',  $url);
			return $output;
		}
					
		if ($task == 'createsamplecontent'){
			/** 
        * insert a sample page and sample blog entry
        */
			// first we need to get the username of the root user to own the content
			// do i need to do a user load? - can i just do a global $user? would that be secure?
			$user = user_load(array('uid' => 1));
			
			require_once 'modules/node/node.pages.inc';
			$node = array ('type' => 'blog_entry');
			$form_state['values']['title'] = st('Hello World');
			$form_state['values']['body'] = '<p>' . st('This is the teaser of my first blog post! The teaser is to encourage people to read the whole article - so write something interesting and catchy!') . '</p><!--break-->
			<p>' . st('And here is the body of the blog. Except, this is kinda boring because it\'s short as it\'s an example!') . '</p>';
			$form_state['values']['name'] = $user->name;
			$form_state['values']['op'] = st('Save');
			drupal_execute('blog_entry_node_form', $form_state, (object)$node);

			// could this be done with drupal_execute - would that be better?
			// TODO: this is "queued for moderation" - is that a good thing? maybe add one comment that is published, and one that is queued?
			$comment = array(
				'nid' => 1, 
				'uid' => 1, // maybe set this to anonymous?
				'pid' => 0,
				'subject' => st('Sample Comment'), 
				// TODO: mention the captcha module?
				'comment' => '<p>' . st('This is a sample comment. Comments can be disabled for the whole blog if you don\'t want them. You could have comments enabled, where all comments go live, or comments need to be authorised by you. (Maybe this will be an option in the installation).') . '</p>',
				'format' => 1,
				'timestamp' => time(),
				'status' => TRUE,  //?
				'name' => st('Sample Author Name'),
				'mail' => 'foo@foo.com',
				'homepage' => 'http://drupal.org'
			);
			comment_save($comment);


			// this will create blog_type node not page unless we reset node and poss. form_state
			// it doesn't make sense though as all values should be changed, unless drupal_execute caches (object)$node ?
			$node = array();
			$form_state = array();  // this may not be needed - to check
			$node = array ('type' => 'page');
			$form_state['values']['title'] = st('About Me');
			$form_state['values']['body'] = st('This is a sample page!');
			$form_state['values']['name'] = $user->name;
			
			/* TODO: to add to primary links menu ?
			$form_state['values']['menu']['title'] = st('About Me');
			$form_state['values']['menu']['menu_parent'] = 'primary-links:0';
		// show primary links menu on theme - shouldn't that auto kick-in once a menu is added as for the page?
			*/
			$form_state['values']['op'] = st('Save');
			drupal_execute('page_node_form', $form_state, (object)$node);
			// end of setting up content

			// and onto the last profile task we go
			$task = 'profile-finished';
			return;
		}
  
  }
	
	// view exports to go here
	function _single_user_blog_setup_views(){
		
	}

	// choose which paths to set up
	function pathauto_setup_form($form_state, $url){	
		$form = array();
		$form['#action'] = $url;
		$form['#redirect'] = FALSE;
		
		drupal_set_title(st('Path Setup'));

		// to use real world data here
		$pathformat_options = array(
			'ymdt' => st('www.example.com/y/m/d/title-of-blog'),
			'yyyymmddt' => st('www.example.com/yyyy/mm/dd/title-of-blog'),
			'yymmt' => st('www.example.com/year/month/title-of-blog'),
			'bt' => st('www.example.com/blog/title-of-blog'),
			
			// need to allow an advanced option to allow user to enter path
		);
		
		$form['pathformat'] = array(
			'#title' => st('URL Format'),
			'#description' => st('Your blog paths can be formatted in various ways. You can either choose one of the preset formats below, or enter your own.'),
			'#type' => 'select',
			'#options' => $pathformat_options,
		);	
		
		$form['task'] = array(
			'#type' => 'hidden',
			'#value' => $task,
		);
		
		$form['submit'] = array(
			'#type' => 'submit',
			'#value' => st('Save and Continue'),
		);

		return $form;
	}
	
	function pathauto_setup_form_submit($form, &$form_state){
		variable_set('pathauto_setup', TRUE);
		// set up pathauto depending on what the user chose
		switch($form_state['values']['pathformat']){
			case 'ymdt':
				variable_set('pathauto_node_blog_entry_pattern', '[y]/[m]/[d]/[title-raw]');
				break;
			case 'yyyymmddt':
				variable_set('pathauto_node_blog_entry_pattern', '[yyyy]/[mm]/[dd]/[title-raw]');
				break;
			case 'yymmt':
				variable_set('pathauto_node_blog_entry_pattern', '[yy]/[mm]/[title-raw]');
				break;
			case 'bt':
				variable_set('pathauto_node_blog_entry_pattern', 'blog/[title-raw]');
				break;
		}

		// set up default page path?
		variable_set('pathauto_node_page_pattern', '[title]');
	}